/*
----------------------------------------------------------------------

	AdAstra - Real Time Kernel

	Alain Chebrou

	aaUsb.h		TinyUSB initialization
				AA specific CDC API

	When		Who	What
	30/03/22	ac	Creation

----------------------------------------------------------------------
*/
#if ! defined AAUSB_H_
#define AAUSB_H_
//--------------------------------------------------------------------------------

#ifdef __cplusplus
extern "C" {
#endif

typedef	void *	cdctHandle_t ;

void			aaUsbInit			(void) ;

// To get a CDC handle. Idx is CDC index from 0, return NULL on error.
cdctHandle_t	cdcGethandle		(uint32_t idx) ;

//	To initialize a USB CDC interface as standard IO descriptor
void			cdcInitStdDev		(aaDevIo_t * pDev, cdctHandle_t hCdc) ;

//--------------------------------------------------------------------------------

void 			cdcPutChar			(cdctHandle_t hCdc, char cc) ;		// Put one char to   dev
char 			cdcGetChar			(cdctHandle_t hCdc) ;				// Get one char from dev
uint32_t		cdcCheckGetChar		(cdctHandle_t hCdc) ;				// Get count of char available to read from dev
uint32_t		cdcCheckPutChar		(cdctHandle_t hCdc) ;				// Get count of char free space to write to dev without blocking

void			cdcWrite 			(cdctHandle_t hCdc, uint8_t * pData, uint32_t count, uint32_t bFlush) ;
void			cdcPutString		(cdctHandle_t hCdc, char * pStr) ;	// Send a string

void			cdcSetOption		(cdctHandle_t hCdc, uint32_t flag, uint32_t bSet) ;

// USB CDC flags to use with cscSetOption()
#define	USB_DEV_CRLF		0x00000001		// cdcPutChar() must convert \n to \r\n

#ifdef __cplusplus
}
#endif
//--------------------------------------------------------------------------------
#endif	// AAUSB_H_
